<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2006 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/

/* 
UPGRADED TO V7 by
Diemux @ www.phpfusion-mods.net
*/

require_once "../maincore.php";
require_once THEMES."templates/admin_header.php";
include LOCALE.LOCALESET."admin/sitelinks.php";

if (!checkrights("PH") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../index.php"); }
if (isset($link_id) && !isNum($link_id)) redirect(FUSION_SELF.$aidlink);
if (isset($cat_id) && !isNum($cat_id)) redirect(FUSION_SELF.$aidlink);
if (!isset($action)) $action = "";

if (isset($status)) {
	if ($status == "del") {
		$title = $locale['400'];
		$message = "<b>".$locale['401']."</b>";
	} elseif ($status == "catdel") {
		$title = $locale['SNP_000'];
		$message = "<br><b>".$locale['SNP_001']."</b><br><br>";
	} elseif ($status == "caterr") {
		$title = $locale['SNP_000'];
		$message = "<br><b>".$locale['SNP_002']."</b><br><br>";
	}
	opentable($title);
	echo "<div align='center'>".$message."</div>\n";
	closetable();
	//tablebreak();
}

if ($action == "refresh") {
	$current_cat = 0; $i = 1; $x = 1;
	$result = dbquery("SELECT t1.link_id AS cat_id, t2.* FROM ".$db_prefix."site_links t1
		LEFT JOIN ".$db_prefix."site_links t2 ON t1.link_id = t2.link_parent
		WHERE t1.link_parent='0' ORDER BY t1.link_order ASC, t2.link_order ASC"
	);
	while($data = dbarray($result)) {
		if ($data['link_parent'] != $current_cat) {
			$result2 = dbquery("UPDATE ".$db_prefix."site_links SET link_order='$x' WHERE link_id='".$data['link_parent']."'");
			$i = 1; $x ++;
		}
		$result2 = dbquery("UPDATE ".$db_prefix."site_links SET link_order='$i' WHERE link_id='".$data['link_id']."'");
		$current_cat = $data['link_parent'];
		$i++;
	}
	redirect(FUSION_SELF.$aidlink);
} elseif ($action == "moveup") {
	$data = dbarray(dbquery("SELECT * FROM ".$db_prefix."site_links WHERE link_order='$order' AND link_parent='$cat_id'"));
	$result = dbquery("UPDATE ".$db_prefix."site_links SET link_order=link_order+1 WHERE link_id='".$data['link_id']."'");
	$result = dbquery("UPDATE ".$db_prefix."site_links SET link_order=link_order-1 WHERE link_id='$link_id'");
	redirect(FUSION_SELF.$aidlink);
} elseif ($action == "movedown") {
	$data = dbarray(dbquery("SELECT * FROM ".$db_prefix."site_links WHERE link_order='$order' AND link_parent='$cat_id'"));
	$result = dbquery("UPDATE ".$db_prefix."site_links SET link_order=link_order-1 WHERE link_id='".$data['link_id']."'");
	$result = dbquery("UPDATE ".$db_prefix."site_links SET link_order=link_order+1 WHERE link_id='$link_id'");
	redirect(FUSION_SELF.$aidlink);
} elseif ($action == "delete") {
	if (isset($cat_id)) {
		$result = dbquery("SELECT * FROM ".$db_prefix."site_links WHERE link_parent='$cat_id'");
		if (dbrows($result)) { redirect(FUSION_SELF.$aidlink."&status=caterr"); exit; }
		else { $link_id = $cat_id; }
	}
	$data = dbarray(dbquery("SELECT * FROM ".$db_prefix."site_links WHERE link_id='$link_id'"));
	$result = dbquery("UPDATE ".$db_prefix."site_links SET link_order=link_order-1 WHERE link_order>'".$data['link_order']."' AND link_parent='".$data['link_parent']."'");
	$result = dbquery("DELETE FROM ".$db_prefix."site_links WHERE link_id='$link_id'");
	redirect(FUSION_SELF.$aidlink."&status=".(isset($cat_id) ? "cat" : "")."del");
} else {
	if (isset($_POST['savecat'])) {
		$cat_name = stripinput($_POST['cat_name']);
		$cat_image = stripinput($_POST['cat_image']);
		$cat_order = isset($_POST['cat_order']) ? $_POST['cat_order'] : "0";
		$cat_collapse = isset($_POST['cat_collapse']) ? 1 : "0";
		if ($action == "edit") {
			$result = dbquery("UPDATE ".$db_prefix."site_links SET
				link_name='$cat_name', link_url='$cat_image', link_collapse='$cat_collapse' WHERE link_id='$cat_id'"
			);
			redirect(FUSION_SELF.$aidlink);
		} else {
			if(!$cat_order) $cat_order = dbresult(dbquery("SELECT MAX(link_order) FROM ".$db_prefix."site_links WHERE link_parent='0'"),0) + 1;
			$result = dbquery("UPDATE ".$db_prefix."site_links SET link_order=link_order+1 WHERE link_order>='$cat_order' AND link_parent='0'");	
			$result = dbquery("INSERT INTO ".$db_prefix."site_links (link_parent, link_name, link_url, link_visibility, link_collapse, link_position, link_window, link_order) VALUES ('0', '$cat_name', '$cat_image', '0', '$cat_collapse', '1', '0', '$cat_order')");
			redirect(FUSION_SELF.$aidlink);
		}
	}
	if ($action == "edit" && isset($cat_id)) {
		$result = dbquery("SELECT * FROM ".$db_prefix."site_links WHERE link_id='$cat_id'");
		$data = dbarray($result);
		$cat_name = $data['link_name'];
		$cat_image = $data['link_url'];
		$cat_collapse = $data['link_collapse'] == 1 ? "checked" : "";
		$cat_order = $data['link_order'];
		$catformaction = FUSION_SELF.$aidlink."&amp;action=edit&amp;cat_id=".$data['link_id'];
		opentable($locale['SNP_014']);
	} else {
		$cat_name = "";
		$cat_image = "";
		$cat_order = "";
		$cat_collapse = "";
		$catformaction = FUSION_SELF.$aidlink;
		opentable($locale['SNP_015']);
	}
	$image_files = makefilelist(INFUSIONS."navigation_panel/images/", ".|..|index.php", true);
	$image_list = makefileopts($image_files, $cat_image);
	echo "<form name='addcatform' method='post' action='$catformaction'>
<table align='center' cellpadding='0' cellspacing='0'>
<tr>
<td class='tbl'>".$locale['SNP_003']."</td>
<td class='tbl'><input type='text' name='cat_name' value='$cat_name' maxlength='100' class='textbox' style='width:240px;'></td>
</tr>
<tr>
<td class='tbl'>".$locale['SNP_004']."</td>
<td class='tbl'>
<select name='cat_image' class='textbox' style='margin-top:5px'>
<option value=''> ".$locale['SNP_005']." </option>
$image_list</select></td>
</tr>\n";
	if ($action != "edit") {
		echo "<tr>
<td class='tbl'>".$locale['SNP_006']."</td>
<td class='tbl'>
<input type='text' name='cat_order'  value='$cat_order' maxlength='2' class='textbox' style='width:40px;'>
&nbsp;".$locale['SNP_011']." <input type='checkbox' name='cat_collapse'  value='1' class='textbox' $cat_collapse>
</td>
</tr>\n";
	} else {
		echo "<tr>
<td class='tbl'>".$locale['SNP_011']."</td>
<td class='tbl'><input type='checkbox' name='cat_collapse'  value='1' class='textbox' $cat_collapse></td>
</tr>\n";
	}
	echo "<tr>
<td align='center' colspan='2' class='tbl'>
<input type='submit' name='savecat' value='".$locale['SNP_007']."' class='button'></td>
</tr>
</table>
</form>\n";
	closetable();
	//tablebreak();
	if (isset($_POST['savelink'])) {
		$link_parent = isNum($_POST['link_parent']) ? $_POST['link_parent'] : 0;
		$link_name = stripinput($_POST['link_name']);
		$link_url = stripinput($_POST['link_url']);
		$link_accessibility = isNum($_POST['link_accessibility']) ? $_POST['link_accessibility'] : "0";
		$link_visibility = isNum($_POST['link_visibility']) ? $_POST['link_visibility'] : $link_accessibility;
		$link_position = isset($_POST['link_position']) ? $_POST['link_position'] : "0";
		$link_window = isset($_POST['link_window']) ? $_POST['link_window'] : "0";
		if ($action == "edit") {
			$result = dbquery("UPDATE ".$db_prefix."site_links SET link_parent='$link_parent', link_name='$link_name', link_url='$link_url', link_visibility='$link_visibility', link_accessibility='$link_accessibility', link_position='$link_position', link_window='$link_window' WHERE link_id='$link_id'");
			redirect(FUSION_SELF.$aidlink);
		} else {
			if(!$link_order) $link_order=dbresult(dbquery("SELECT MAX(link_order) FROM ".$db_prefix."site_links WHERE link_parent='$link_parent'"),0)+1;
			$result = dbquery("UPDATE ".$db_prefix."site_links SET link_order=link_order+1 WHERE link_order>='$link_order' AND link_parent='$link_parent'");
			$result = dbquery("INSERT INTO ".$db_prefix."site_links (link_parent, link_name, link_url, link_visibility, link_accessibility, link_collapse, link_position, link_window, link_order) VALUES ('$link_parent', '$link_name', '$link_url', '$link_visibility', '$link_accessibility', '0', '$link_position', '$link_window', '$link_order')");
			redirect(FUSION_SELF.$aidlink);
		}
	}
	if ($action == "edit" && isset($link_id)) {
		$result = dbquery("SELECT * FROM ".$db_prefix."site_links WHERE link_id='$link_id'");
		$data = dbarray($result);
		$link_parent = $data['link_parent'];
		$link_name = $data['link_name'];
		$link_url = $data['link_url'];
		$link_visibility = $data['link_visibility'];
		$link_accessibility = $data['link_accessibility'];
		$link_order = $data['link_order'];
		$pos1_check = ($data['link_position']=="1" ? " checked" : "");
		$pos2_check = ($data['link_position']=="2" ? " checked" : "");
		$pos3_check = ($data['link_position']=="3" ? " checked" : "");
		$window_check = ($data['link_window']=="1" ? " checked" : "");
		$formaction = FUSION_SELF.$aidlink."&amp;action=edit&amp;link_id=".$data['link_id'];
		opentable($locale['410']);
	} else {
		$link_parent = 0;
		$link_name = "";
		$link_url = "";
		$link_visibility = "";
		$link_accessibility = "";
		$link_order = "";
		$pos1_check = " checked";
		$pos2_check = "";
		$pos3_check = "";
		$window_check = "";
		$formaction = FUSION_SELF.$aidlink;
		opentable($locale['411']);
	}
	$visibility_opts = "<option value='none'>&nbsp;</option>\n";
	$accessibility_opts = ""; $sel = "";
	$user_groups = getusergroups();
	while(list($key, $user_group) = each($user_groups)){
		$sel = ($link_visibility == $user_group['0'] ? " selected" : "");
		$visibility_opts .= "<option value='".$user_group['0']."'$sel>".$user_group['1']."</option>\n";
		$sel = ($link_accessibility == $user_group['0'] ? " selected" : "");
		$accessibility_opts .= "<option value='".$user_group['0']."'$sel>".$user_group['1']."</option>\n";
	}
	$cat_opts = "";
	$result = dbquery("SELECT link_id, link_name FROM ".$db_prefix."site_links WHERE link_parent='0' ORDER BY link_order");
	$cat_count = dbrows($result);
	if ($cat_count != 0) {
		while($data = dbarray($result)) {
			$cat_opts .= "<option value='".$data['link_id']."'".($link_parent == $data['link_id'] ? " selected" : "").">".$data['link_name']."</option>\n";
		}
	}
	echo "<form name='layoutform' method='post' action='$formaction'>
<table align='center' cellpadding='0' cellspacing='0'>
<tr>
<td class='tbl'>".$locale['SNP_008']."</td>
<td class='tbl'><select name='link_parent' class='textbox'>
$cat_opts
</select>
</td>
</tr>
<tr>
<td class='tbl'>".$locale['420']."</td>
<td class='tbl'><input type='text' name='link_name' value='$link_name' maxlength='100' class='textbox' style='width:240px;'></td>
</tr>
<tr>
<td class='tbl'>".$locale['421']."</td>
<td class='tbl'><input type='text' name='link_url' value='$link_url' maxlength='200' class='textbox' style='width:240px;'></td>
</tr>
<tr>
<td class='tbl'>".$locale['422']."</td>
<td class='tbl'><select name='link_visibility' class='textbox'>
$visibility_opts</select>\n";
	if ($action != "edit") {
		echo $locale['423']."
<input type='text' name='link_order'  value='$link_order' maxlength='2' class='textbox' style='width:40px;'>";
	}
	echo "</td>
</tr>
<tr>
<td class='tbl'>".$locale['SNP_009']."</td>
<td class='tbl'><select name='link_accessibility' class='textbox'>
$accessibility_opts</select>
</td>
</tr>
<tr>
<td valign='top' class='tbl'>".$locale['424']."</td>
<td class='tbl'><input type='radio' name='link_position' value='1'$pos1_check> ".$locale['425']."<br>
<input type='radio' name='link_position' value='2'$pos2_check> ".$locale['426']."<br>
<input type='radio' name='link_position' value='3'$pos3_check> ".$locale['427']."<hr>
<input type='checkbox' name='link_window' value='1'$window_check> ".$locale['428']."</td>
</tr>
<tr>
<td align='center' colspan='2' class='tbl'><input type='submit' name='savelink' value='".$locale['429']."' class='button'></td>
</tr>
</table>
</form>\n";
	closetable();
	//tablebreak();
	opentable($locale['412']);
	echo "<table align='center' cellpadding='0' cellspacing='1' width='500' class='tbl-border'>";
	$result = dbquery("SELECT t1.link_id AS cat_id, t1.link_name AS cat_name, t1.link_url AS cat_image,
		t1.link_order AS cat_order, t1.link_collapse AS cat_collapse, t2.* FROM ".$db_prefix."site_links t1
		LEFT JOIN ".$db_prefix."site_links t2 ON t1.link_id = t2.link_parent
		WHERE t1.link_parent='0' ORDER BY t1.link_order ASC, t2.link_order ASC"
	);
	if (dbrows($result) != 0) {
		$current_cat = 0; $cat_links = 0;
		$i = 0; $k = 1; $c = 1;
		while($data = dbarray($result)) {
			if ($data['cat_id'] != $current_cat) {
				if ($current_cat != 0) {
					if ($cat_links == 0) {
						echo "<tr>\n<td align='center' colspan='6' class='tbl1'>".$locale['436']."</td>\n</tr>\n";
					}
				}
				$cat_links = dbcount("(link_id)", DB_SITE_LINKS, "link_parent='".$data['cat_id']."'");
				$current_cat = $data['cat_id'];
				$k = 1;
				echo "<tr>
<td colspan='3' class='tbl2'>
<img src='".BASEDIR."infusions/navigation_panel/images/".$data['cat_image']."' alt='".$data['cat_image']."'>&nbsp;
<b>".$data['cat_name']."
&nbsp;<img src='".BASEDIR."infusions/navigation_panel/images/links_".($data['cat_collapse'] == 1 ? "hidden" : "shown").".gif' alt='[ ".($data['cat_collapse'] == 1 ? $locale['SNP_012'] : $locale['SNP_013'])." ]' title='[ ".($data['cat_collapse'] == 1 ? $locale['SNP_012'] : $locale['SNP_013'])." ]'></b>
</td>
<td align='center' width='1%' class='tbl2' style='white-space:nowrap'>".$data['cat_order']."
<td align='center' width='1%' class='tbl2' style='white-space:nowrap'>\n";
				if ($cat_count > 1) {
					$up = $data['cat_order'] - 1;
					$down = $data['cat_order'] + 1;
					if ($c == 1) {
						echo "<a href='".FUSION_SELF.$aidlink."&amp;action=movedown&amp;order=$down&amp;cat_id=0&amp;link_id=".$data['cat_id']."'><img src='".THEME."images/down.gif' alt='".$locale['441']."' title='".$locale['443']."' style='border:0px;'></a>\n";
					} elseif ($c < $cat_count) {
						echo "<a href='".FUSION_SELF.$aidlink."&amp;action=moveup&amp;order=$up&amp;cat_id=0&amp;link_id=".$data['cat_id']."'><img src='".THEME."images/up.gif' alt='".$locale['440']."' title='".$locale['442']."' style='border:0px;'></a>\n";
						echo "<a href='".FUSION_SELF.$aidlink."&amp;action=movedown&amp;order=$down&amp;cat_id=0&amp;link_id=".$data['cat_id']."'><img src='".THEME."images/down.gif' alt='".$locale['441']."' title='".$locale['443']."' style='border:0px;'></a>\n";
					} else {
						echo "<a href='".FUSION_SELF.$aidlink."&amp;action=moveup&amp;order=$up&amp;cat_id=0&amp;link_id=".$data['cat_id']."'><img src='".THEME."images/up.gif' alt='".$locale['440']."' title='".$locale['442']."' style='border:0px;'></a>\n";
					}
				}
				$c ++;
				echo "</td>
<td align='center' width='1%' class='tbl2' style='white-space:nowrap'><a href='".FUSION_SELF.$aidlink."&amp;action=edit&amp;cat_id=".$data['cat_id']."'>".$locale['434']."</a> -
<a href='".FUSION_SELF.$aidlink."&amp;action=delete&amp;cat_id=".$data['cat_id']."'>".$locale['435']."</a></td>
</tr>
<tr>
<td class='tbl2'><b>".$locale['430']."</b></td>
<td align='center' width='1%' class='tbl2' style='white-space:nowrap'><b>".$locale['431']."</b></td>
<td align='center' width='1%' class='tbl2' style='white-space:nowrap'><b>".$locale['SNP_010']."</b></td>
<td align='center' colspan='2' width='1%' class='tbl2' style='white-space:nowrap'><b>".$locale['432']."</b></td>
<td align='center' width='1%' class='tbl2' style='white-space:nowrap'><b>".$locale['433']."</b></td>
</tr>\n";
			}
			if ($cat_links != 0) {
				echo "<tr>\n<td class='tbl1'>";
				if ($data['link_position'] == 3) echo "<i>";
				if ($data['link_name'] != "---" && $data['link_url'] == "---") {
					echo "<b>".$data['link_name']."</b>\n";
				} else if ($data['link_name'] == "---" && $data['link_url'] == "---") {
					echo "<hr>\n";
				} else {
					$link = explode(" ", $data['link_name']);
					for($i = 0; $i < count($link); $i ++) {
						$ext = strrchr($link[$i], ".");
						if ($ext == ".gif" || $ext == ".jpg" || $ext == ".png") {
							$link[$i] = "<img src='".BASEDIR.$link[$i]."' alt=''>";
						}
					}
					$data['link_name'] = implode(" ", $link);
					$data['link_name'] = preg_replace('#\[b\](.*?)\[/b\]#si', '<b>\1</b>', $data['link_name']);
					$data['link_name'] = preg_replace('#\[i\](.*?)\[/i\]#si', '<i>\1</i>', $data['link_name']);
					$data['link_name'] = preg_replace('#\[u\](.*?)\[/u\]#si', '<u>\1</u>', $data['link_name']);
					$data['link_name'] = preg_replace('#\[color=(black|blue|brown|cyan|gray|green|lime|maroon|navy|olive|orange|purple|red|silver|violet|white|yellow)\](.*?)\[/color\]#si', '<span style=\'color:\1\'>\2</span>', $data['link_name']);
					if (strstr($data['link_url'], "http://") || strstr($data['link_url'], "https://")) {
						echo "<img src='".THEME."images/bullet.gif' alt=''> <a href='".$data['link_url']."'>".$data['link_name']."</a>\n";
					} else {
						echo "<img src='".THEME."images/bullet.gif' alt=''> <a href='".BASEDIR.$data['link_url']."'>".$data['link_name']."</a>\n";
					}
				}
				if ($data['link_position'] == 3) echo "</i>";
				echo "</td>
<td align='center' width='1%' class='tbl1' style='white-space:nowrap'>".getgroupname($data['link_visibility'])."</td>
<td align='center' width='1%' class='tbl1' style='white-space:nowrap'>".getgroupname($data['link_accessibility'])."</td>
<td align='center' width='1%' class='tbl2' style='white-space:nowrap'>".$data['link_order']."</td>
<td align='center' width='1%' class='tbl1' style='white-space:nowrap'>\n";
				if ($cat_links > 1) {
					$up = $data['link_order'] - 1;
					$down = $data['link_order'] + 1;
					if ($k == 1) {
						echo "<a href='".FUSION_SELF.$aidlink."&amp;action=movedown&amp;order=$down&amp;cat_id=".$data['cat_id']."&amp;link_id=".$data['link_id']."'><img src='".THEME."images/down.gif' alt='".$locale['441']."' title='".$locale['443']."' style='border:0px;'></a>\n";
						} elseif ($k < $cat_links) {
							echo "<a href='".FUSION_SELF.$aidlink."&amp;action=moveup&amp;order=$up&amp;cat_id=".$data['cat_id']."&amp;link_id=".$data['link_id']."'><img src='".THEME."images/up.gif' alt='".$locale['440']."' title='".$locale['442']."' style='border:0px;'></a>\n";
							echo "<a href='".FUSION_SELF.$aidlink."&amp;action=movedown&amp;order=$down&amp;cat_id=".$data['cat_id']."&amp;link_id=".$data['link_id']."'><img src='".THEME."images/down.gif' alt='".$locale['441']."' title='".$locale['443']."' style='border:0px;'></a>\n";
						} else {
							echo "<a href='".FUSION_SELF.$aidlink."&amp;action=moveup&amp;order=$up&amp;cat_id=".$data['cat_id']."&amp;link_id=".$data['link_id']."'><img src='".THEME."images/up.gif' alt='".$locale['440']."' title='".$locale['442']."' style='border:0px;'></a>\n";
					}
				}
				$k++;
				echo "</td>
<td align='center' width='1%' class='tbl1' style='white-space:nowrap'><a href='".FUSION_SELF.$aidlink."&amp;action=edit&amp;link_id=".$data['link_id']."'>".$locale['434']."</a> -
<a href='".FUSION_SELF.$aidlink."&amp;action=delete&amp;link_id=".$data['link_id']."'>".$locale['435']."</a></td>
</tr>\n";
			}
		}
	}
	if ($cat_links == 0) {
		echo "<tr>\n<td align='center' colspan='6' class='tbl1'>".$locale['436']."</td>\n</tr>\n";
	}
	if (dbrows($result) > 1) echo "<tr>\n<td align='center' colspan='6' class='tbl1'>[ <a href='".FUSION_SELF.$aidlink."&amp;action=refresh'>".$locale['444']."</a> ]</td>\n</tr>\n";
	echo "</table>\n";
	closetable();
}

require_once THEMES."templates/footer.php";
?>